<?php

// Convert a json file to a lua table

// Settings

$action = $_SERVER['PHP_SELF'];



// Remove folders function

function removeFolders($file) {

$file = explode("/", $file);
$file = $file[count($file)-1];
return($file);

}

//$test = true;


//#########################################################
// Functions
//#########################################################



// Make a function that checks if a keyframe on the timeline exists in the mainline

function keyframeExists($animationId,$timelineId,$keyframeId) {

	global $xml;
	
	if($xml->entity->animation[$animationId]->mainline->key[$keyframeId]) {
		foreach($xml->entity->animation[$animationId]->mainline->key[$keyframeId] as $object) {
	
			if($object[timeline]==$timelineId) {
				$exists = true;
			}

		}
	}
	
	return($exists);
}










if(!$scale) {
	$scale = 4;
}

if(!$atlas) {
	$atlas = "atlas";
}


if(!$anim0Frames) {
	$anim0Frames = 100;
}

if(!$anim1Frames) {
	$anim1Frames = 0;
}

if(!$anim2Frames) {
	$anim2Frames = 0;
}

if(!$anim3Frames) {
	$anim3Frames = 0;
}

if(!$anim4Frames) {
	$anim4Frames = 0;
}

// Browse button

print("<h2>Build a table from a Spriter scml (xml) file</h2>

<form enctype=multipart/form-data method=post>

<table border=0 cellpadding=5>

<TR>

<TD>
<input type=hidden name=MAX_FILE_SIZE value=1500000>
<input type=hidden name=upload value=1>
<input type=file size=90 style='font-size: 11px;' name=mailfile>
</TD>

<td>Scale @<input type=text size=1 name=scale value='$scale'>x</td>

<td><div style='margin-left: 20px;'>Atlas <input type=text size=30 name=atlas value='$atlas'></div></td>

</table>


<table cellpadding=10>

<tr>

<td># Frames</td>

<td>Animation[0] <input type=text size=2 name=anim0Frames value='$anim0Frames'></td>
<td>Animation[1] <input type=text size=2 name=anim1Frames value='$anim1Frames'></td>
<td>Animation[2] <input type=text size=2 name=anim2Frames value='$anim2Frames'></td>
<td>Animation[3] <input type=text size=2 name=anim3Frames value='$anim3Frames'></td>
<td>Animation[4] <input type=text size=2 name=anim4Frames value='$anim4Frames'></td>

<td><input type=submit value=' Build '></td>

</tr>

</table>

</form>
");

if ($_REQUEST[upload] == 1) {

// Upload was pressed

$file = file($_FILES['mailfile']['tmp_name']);

$fileName = $_FILES['mailfile']['name'];

print("<h3>$fileName</h3>");
 



$xmlCode = implode("\n", $file);

$xml = new SimpleXMLElement($xmlCode);



// Build #frames array

$numFrames = Array();
$numFrames[0] = $anim0Frames;
$numFrames[1] = $anim1Frames;
$numFrames[2] = $anim2Frames;
$numFrames[3] = $anim3Frames;
$numFrames[4] = $anim4Frames;


//#########################################################
// Create parent sprite
//#########################################################



//#########################################################
// <folder> and <file> section
// Put the images in an table with 'id' as key
//#########################################################

$files = Array();

// For each folder

foreach($xml->folder as $folder) {

//	print("folder id: ".$folder[id]."<BR>");
	
	$folderId = intval($folder[id]);

	// for each file
	
	foreach($folder->file as $file) {
			
		$name = str_replace("/", "", $file[0][name]);
		$id = intval($file[id]);
		$width = $file[width];
		$height = $file[height];
	
		// Record this file in our array, for later use
	
		$fileDetails = Array();
		$fileDetails['name'] = $name;
		$fileDetails['width'] = $width;
		$fileDetails['height'] = $height;

		$files[$folderId][$id] = $fileDetails;

	}

}





//#########################################################
// Mainline part
//
// Build the sprites
// Make bones parent sprites
//
//#########################################################

// Array to store info about the bones
$bones = Array();



$luaCode .= "\nlocal bones = {}\n\n";

//#########################################################
// Part 1 - Bones
//#########################################################

$luaCode .= "-- Setup bones\n\n";

// For each bone

foreach($xml->entity[0]->animation[0]->mainline->key[0] as $mainlineKey) {

	// Record the parent
	
	// If there's a parent
	
	if($mainlineKey[parent]) {
	
		// If this is an image
		
		if($mainlineKey[z_index]) {
		
			$imageParents[intval($mainlineKey[timeline])] = intval($mainlineKey[parent]);
		
		}
		
	// End if there's a parent
	}
	
	



	unset($parentTimeline);

	// If it's a bone (doesn't have abs_x but has id)
		
	if(!$mainlineKey[z_index]) {

		$boneId = intval($mainlineKey[id]);
		$parent = $mainlineKey[parent];
		$timelineId = intval($mainlineKey[timeline]);

		// Record my name in an array
		// We need this later to filter out anything that Spriter wrongly adds
		// (Glitch in current where it doesn't delete some stuff from timeline
		
		// Get this bones name

		$name = (string)$xml->entity[0]->animation[0]->timeline[$timelineId][name];
		
		$names[] = $name;

		// Create the sprite

		$luaCode .= "-- $name

local sprite = Sprite.new()\n";

		if($mainlineKey[parent]) {
			$luaCode .= "bones[$parent].sprite:addChild(sprite)\n";
		} else {
			$luaCode .= "mainSprite:addChild(sprite)\n";
		}
		
		
		$boneInfo = Array(
			'id'=>$boneId,
			'parent'=>$mainlineKey[parent]
		);
		$bones[$name] = $boneInfo;

$luaCode .= "bones[$boneId] = {}
bones[$boneId].sprite = sprite\n\n";

	// end if this is a bone
	
	}

// End for each item in keyframe 0 on mainline
}





//#########################################################
// Part 2 - Image Sprites
//#########################################################

$luaCode .= "-- Setup image sprites\n\n";

$luaCode .= "local sprites = {}\n";

$sprites = Array();

// For each image

foreach($xml->entity->animation[0]->timeline as $timeline) {

	$name = (string)$timeline[name];
	$id = intval($timeline[id]);
	
	if($timeline->key[0]->object) {
	
	// Get parent
	
	$parent = $imageParents[$id];
	
		unset($parentTimeline);
		
		$folderId = intval($timeline->key[0]->object[folder]);
		$fileId = intval($timeline->key[0]->object[file]);


		$spriteInfo = Array(
			'id'=>$id,
			'parent'=>$parent
		);
		
		$sprites[$name] = $spriteInfo;
		
		$names[] = $name;
	
		$x = str_replace(".00", "",number_format(floatval($timeline->key[0]->object[abs_x]), 2, ".", ""));
		$y = number_format(floatVal($timeline->key[0]->object[abs_y]),2)*-1;
		
		$angle = str_replace(".00", "",number_format(360 - abs(floatval($timeline->key[0]->object[abs_angle])), 2, ".", ""));
		$scaleX = str_replace(".00", "",number_format(abs(floatval($timeline->key[0]->object[abs_scale_x])), 2, ".", ""));
		$scaleY = str_replace(".00", "",number_format(abs(floatval($timeline->key[0]->object[abs_scale_y])), 2, ".", ""));

		$abs_pivot_x = number_format(floatval($timeline->key[0]->object[abs_pivot_x]),2);
		$abs_pivot_y = number_format(1- floatVal($timeline->key[0]->object[abs_pivot_y]),2);

		if(!$x) {
			$x = 0;
		}

		if(!$y) {
			$y = 0;
		}

		// Create the sprite

$luaCode .= "\n-- $name ---------

sprites[$id] = {}
local sprite = Sprite.new()\n";


		if(strlen($parent)>0) {

			$luaCode .= "bones[$parent].sprite:addChild(sprite)\n";
		} else {
			$luaCode .= "mainSprite:addChild(sprite)\n";
		}
		


$luaCode .= "local img = Bitmap.new($atlas:getTextureRegion(\"".$files[$folderId][$fileId]['name']."\"))
sprite:addChild(img)\n";


		if($abs_pivot_x != 0 && $abs_pivot_y != 0) {
			$luaCode .= "img:setAnchorPoint($abs_pivot_x,$abs_pivot_y)\n";
		}

		$luaCode .= "sprites[$id].sprite = sprite\n";



		// Now adjust x and y by however much the anchor point is
		// This gets sprites rotating correctly

		$x += $files[$fileId][width]*$abs_pivot_x;
		$y += $files[$fileId][height]*$abs_pivot_y;

		//$luaCode .= "sprites[$spriteArrayCounter].time = 1\n";
	
	// end if this is a sprite reference
	
	}


// End for each item in key 0, timeline section
}






//#########################################################
// Build movieClip Timeline
//#########################################################

// Foreach animation

foreach($xml->entity[0]->animation as $animation) {

	$animationId = intval($animation[id]);
	$animationName = (string)$animation[name];
	
	// Work out gTime for this animation
	
	//$numFrames = $_POST['numFrames'];

	$numFramesThisAnimation = $numFrames[$animationId];
	$gTime = $numFramesThisAnimation / 1000;
	
	$readOutCode.= "<b>animationName: $animationName
	<BR>
	animationId: $animationId<BR>
	Number of frames: $numFramesThisAnimation</b><BR>";

	// For each <timeline>

	foreach($animation->timeline as $timeline) {
	
		// Get timeline
	
		$timelineId = intval($timeline[id]);
		$name = (string)$timeline[name];
		$spriteId = $sprites[$name][id];
		$boneId = $bones[$name][id];
	
		unset($isBone);
	
		if($timeline[object_type]=="bone") {
			$isBone = true;
		}
	
		// If this sprite or bone is actually there
	
		if(in_array($name, $names)) {
	
			$readOutCode.= "<b>timeline id: $timelineId</b><BR>";
			$readOutCode.= "name: $name<BR>";
		
			if($isBone) {
				$readOutCode.= "boneId: $boneId<BR>";
			} else {
				$readOutCode.= "spriteId: $spriteId<BR>";
			}

		
			// For each keyframe in that timeline

			foreach($timeline->key as $keyFrame) {
			
				// Check entry exists in mainline for this timeline keyframe
			
				$keyframeId = intval($keyFrame[id]);
			
				if(keyframeExists($animationId,$timelineId,$keyframeId)) {
			
					$readOutCode.= "keyframe id: $keyframeId<BR>";
			
					unset($angle);
					unset($scale_x);
					unset($scale_y);
					unset($x);
					unset($y);
					unset($time);
					unset($spriteAdjustEvent);
					unset($isAdjustEvent);
		
					$time = intval($keyFrame[time]);
					$ourTime = floor($time * $gTime);
					
					// work out easing
					
					$curveType = $keyFrame[curve_type];
					$c1 = $keyFrame[c1];
					
					//print("C: $curveType");
					
					unset($easing);
					
					if($curveType) {
					
					$readOutCode.= "curveType: $curveType ($c1)<BR>";
					
				
					
					// in / out bounce
					
					if($curveType=="bezier") {
					


						if($c1==0) {
							$easing = "inBounce";
						} else {
							$easing = "outBounce";
						}
					
					}
					
					
					// in / out quadratic
					
					if($curveType=="quadratic") {

						if($c1==0) {
							$easing = "inQuadratic";
						} else {
							$easing = "outQuadratic";
						}
					
					}
					
					// End if curve type
					}
					
					

			
					$readOutCode.= "keyframe time: $time. x gtime($gTime) = $ourTime<BR>";
			
					$time = $ourTime;
						
					if($time<1) {
						$time = 1;
					}
			
			

			
			
					if($timeline[object_type]=="bone") {
				
						$angle = number_format(360 - abs(floatval($keyFrame->bone[angle])),2);
						
						//$angle = floor($angle);
						
						$scale_x = number_format(floatval($keyFrame->bone[scale_x]),2);
						$scale_y = number_format(floatval($keyFrame->bone[scale_y]),2);
						$x = number_format(floatval($keyFrame->bone[x])/$scale,2);
						$y = number_format(floatval($keyFrame->bone[y])/$scale,2)*-1;
				
					} else {
				
						$angle = number_format(360 - abs(floatval($keyFrame->object[angle])),2);
						
						//$angle = floor($angle);
						
						$scale_x = number_format(floatval($keyFrame->object[scale_x]),2);
						$scale_y = number_format(floatval($keyFrame->object[scale_y]),2);
						$x = number_format(floatval($keyFrame->object[x])/$scale,2);
						$y = number_format(floatval($keyFrame->object[y])/$scale,2)*-1;
				
					}
			

					if($angle==nil || $angle==360) {
						$angle=0;
					}
			
					if($scale_x==0 || !$scale_x) {
						$scale_x = 1;
					}
			
					if($scale_y==0 || !$scale_y) {
						$scale_y=1;
					}
			
			
			
					// Decide what has changed and add to timeline table
			
					unset($timeLineEvent);
			
					// Get time last frame
			
					if($keyframeId > 0) {
			
						$timeLastKeyframe = $xml->entity[0]->animation[$animationId]->timeline[intval($timelineId)]->key[$keyframeId-1][time];
						$timeLastKeyframe = floor($timeLastKeyframe * $gTime);
			
					} else {
			
						$timeLastKeyframe = 1;
					}
			
					
			

			

			
					if(!$timeLastKeyframe) {
						$timeLastKeyframe = 1;
					}
			
					if($timeLastKeyframe>1) {
						$fromFrame = $timeLastKeyframe+1;
					} else {
						$fromFrame = $timeLastKeyframe;
					}
					$toFrame = $time;
			
					if($fromFrame==1 && $toFrame == 1) {
						$isAdjustEvent = true;
						$readOutCode.= "<u>This is a sprite adjust event</u><BR>";
					} else {
						$readOutCode.= "<u>This is a TIMELINE event</u><BR>";
						$readOutCode.= "timeLastKeyframe: $timeLastKeyframe (fromFrame will be $fromFrame)<BR>";
					}
			
			
			
			
			
			
					// x changed
			
					// Get x last keyframe
			
					if($keyframeId > 0) {
			
						if($isBone) {
							$xLastFrame = number_format(floatval($xml->entity[0]->animation[$animationId]->timeline[intval($timelineId)]->key[$keyframeId-1]->bone[x])/$scale,2);
						} else {
							$xLastFrame = number_format(floatval($xml->entity[0]->animation[$animationId]->timeline[intval($timelineId)]->key[$keyframeId-1]->object[x])/$scale,2);
						}
			
					} else {
			
						$xLastFrame = 0;
				
					}
		
			
					$readOutCode.= "xLastFrame: $xLastFrame, now: $x<BR>";
			
					if($xLastFrame != $x) {
			
						if($easing) {
							$timeLineEvent .= "x=&#123;$xLastFrame,$x,\"$easing\"&#125;,";
						} else {
							$timeLineEvent .= "x=&#123;$xLastFrame,$x&#125;,";
						}

						// If this is the first frame of timeline, where we adjust sprites
				
						if($keyframeId==0) {
	
							if($isBone) {
								$spriteAdjustEvent .= "bones[$boneId].sprite:setX($x)\n";
							} else {
								$spriteAdjustEvent .= "sprites[$spriteId].sprite:setX($x)\n";
							}

						}
	
					}
			
			
			
			
						
					// y changed
			
					// Get y last keyframe
			
					if($keyframeId > 0) {
			
						if($isBone) {
							$yLastFrame = number_format(floatval($xml->entity[0]->animation[$animationId]->timeline[intval($timelineId)]->key[$keyframeId-1]->bone[y])/$scale,2)*-1;
						} else {
							$yLastFrame = number_format(floatval($xml->entity[0]->animation[$animationId]->timeline[intval($timelineId)]->key[$keyframeId-1]->object[y])/$scale,2)*-1;
						}
			
					} else {
			
						$yLastFrame = 0;
				
					}
			
					$readOutCode.= "yLastFrame: $yLastFrame, now: $y<BR>";
			
					if($xLastFrame != $x) {
			
						if($easing) {
							$timeLineEvent .= "y=&#123;$yLastFrame,$y,\"$easing\"&#125;,";
						} else {
							$timeLineEvent .= "y=&#123;$yLastFrame,$y&#125;,";
						}

						// If this is the first frame of timeline, where we adjust sprites
				
						if($keyframeId==0) {
	
							if($isBone) {
								$spriteAdjustEvent .= "bones[$boneId].sprite:setY($y)\n";
							} else {
								$spriteAdjustEvent .= "sprites[$spriteId].sprite:setY($y)\n";
							}

						}
	
					}
			
			
			
			
			
					// scale_x changed
			
					// Get scale_x last keyframe
			
					if($keyframeId > 0) {
			
						if($isBone) {
							$scale_xLastKeyframe = number_format(floatval($xml->entity[0]->animation[$animationId]->timeline[intval($timelineId)]->key[$keyframeId-1]->bone[scale_x]), 2);
						} else {
							$scale_xLastKeyframe = number_format(floatval($xml->entity[0]->animation[$animationId]->timeline[intval($timelineId)]->key[$keyframeId-1]->object[scale_x]),2);
						}
			
					} else {
						$scale_xLastKeyframe = 1;
					}
			
					// If the previous keyframe was 0, and the previous scale_x was 0, set it to 1
			
					if($key[$keyframeId-1]==0 && $scale_xLastKeyframe==0) {
						$scale_xLastKeyframe = 1;
					}

						if($scale_xLastKeyframe != $scale_x) {
				
							$readOutCode.= "Scale x changed. Last frame: $scale_xLastKeyframe, this frame: $scale_x<BR>";
					
							$scale_x = number_format(floatVal($scale_x), 2);
					
							// not the first frame
					
							if($keyframeId==0) {
						
								if($isBone) {
									$spriteAdjustEvent .= "bones[$boneId].sprite:setScaleX($scale_x)\n";
								} else {
									$spriteAdjustEvent .= "sprites[$spriteId].sprite:setScaleX($scale_x)\n";
							
								}

							} else {
					
								$fromScaleX = $scale_xLastKeyframe;

									$timeLineEvent .= "scaleX=&#123;$fromScaleX,$scale_x,\"$easing\"&#125;,";
									
								if($easing) {
									$timeLineEvent .= "scaleX=&#123;$fromScaleX,$scale_x,\"$easing\"&#125;,";
								} else {
									$timeLineEvent .= "scaleX=&#123;$fromScaleX,$scale_x&#125;,";
								}
						
							}
						}
				
				
				
				
					// scale_y changed
			
					// Get scale_y last keyframe
			
					if($keyframeId > 0) {
			
						if($isBone) {
							$scale_yLastKeyframe = number_format(floatval($xml->entity[0]->animation[$animationId]->timeline[intval($timelineId)]->key[$keyframeId-1]->bone[scale_y]), 2);
						} else {
							$scale_yLastKeyframe = number_format(floatval($xml->entity[0]->animation[$animationId]->timeline[intval($timelineId)]->key[$keyframeId-1]->object[scale_y]),2);
						}
			
					} else {
						$scale_yLastKeyframe = 1;
					}
			
					// If the previous keyframe was 0, and the previous scale_x was 0, set it to 1
			
					if($key[$keyframeId-1]==0 && $scale_yLastKeyframe==0) {
						$scale_yLastKeyframe = 1;
					}

						if($scale_yLastKeyframe != $scale_y) {
				
							$readOutCode.= "Scale y changed. Last frame: $scale_yLastKeyframe, this frame: $scale_y<BR>";
					
							$scale_y = number_format(floatVal($scale_y), 2);
					
							// not the first frame
					
							if($keyframeId==0) {
						
								if($isBone) {
									$spriteAdjustEvent .= "bones[$boneId].sprite:setScaleY($scale_y)\n";
								} else {
									$spriteAdjustEvent .= "sprites[$spriteId].sprite:setScaleY($scale_y)\n";
							
								}

							} else {
					
								$fromScaleY = $scale_yLastKeyframe;

								if($easing) {
									$timeLineEvent .= "scaleY=&#123;$fromScaleY,$scale_y,\"$easing\"&#125;,";
								} else {
									$timeLineEvent .= "scaleY=&#123;$fromScaleY,$scale_y&#125;,";
								}
						
							}
						}
				
				
				
				
							

	
						// angle changed
				
						// Get angle & spin from last keyframe
			
						if($keyframeId > 0) {
				
							if($isBone) {
								$angleLastKeyframe = number_format(360 - abs(floatval($xml->entity[0]->animation[$animationId]->timeline[intval($timelineId)]->key[$keyframeId-1]->bone[angle])),2);
								//$angleLastKeyframe = floor($angleLastKeyframe);
								
								$spin = $xml->entity[0]->animation[$animationId]->timeline[intval($timelineId)]->key[$keyframeId-1][spin];
							} else {
								$angleLastKeyframe = number_format(360 - abs(floatval($xml->entity[0]->animation[$animationId]->timeline[intval($timelineId)]->key[$keyframeId-1]->object[angle])),2);
								$spin = $xml->entity[0]->animation[$animationId]->timeline[intval($timelineId)]->key[$keyframeId-1][spin];
								//$angleLastKeyframe = floor($angleLastKeyframe);
								
							}
							
							$readOutCode.= "spin (coming out of last frame): $spin<BR>";

					
						} else {
				
							$angleLastKeyframe = 0;
					
						}
					
						if(!$angleLastKeyframe) {
							$angleLastKeyframe = 0;
						}
					
						if($angleLastKeyframe==360) {
							$angleLastKeyframe = 0;
						}
				
					

						if($angleLastKeyframe != $angle) {
					
							$readOutCode.= "Angle changed. Last frame: $angleLastKeyframe, this frame: $angle, spin (coming out of last frame): $spin<BR>";

							$fromAngle = $angleLastKeyframe;
							$toAngle = $angle;
				
							if($spin==-1) {
					
								// Clockwise spin
						
								// How much have we rotated?
						
								if($toAngle < $fromAngle) {
									// rotation takes us over 0
									$angleA = 360 - $fromAngle;
									$rotated = $toAngle + $angleA;
								} else {
									$rotated = $toAngle -$fromAngle;
								}

								
								if($easing) {
									$timeLineEvent .= "rotation=&#123;$fromAngle,$fromAngle+$rotated,\"$easing\"&#125;,";
								} else {
									$timeLineEvent .= "rotation=&#123;$fromAngle,$fromAngle+$rotated&#125;,";
								}
						
							} else {
					
								// Anti-Clockwise spin
							
								// How much have we rotated?
						
								if($toAngle > $fromAngle) {
									// rotation takes us over 0
									$angleA = 360 - $toAngle;
									$rotated = $fromAngle + $angleA;
								} else {
									$rotated = abs($toAngle - $fromAngle);
								}
					

								
								if($easing) {
									$timeLineEvent .= "rotation=&#123;$fromAngle,$fromAngle-$rotated,\"$easing\"&#125;,";
								} else {
									$timeLineEvent .= "rotation=&#123;$fromAngle,$fromAngle-$rotated&#125;,";
								}

							}
					
							if($isBone) {

								$spriteAdjustEvent .= "bones[$boneId].sprite:setRotation($toAngle)\n";
							} else {
								$spriteAdjustEvent .= "sprites[$spriteId].sprite:setRotation($toAngle)\n";
							}
					

				
						}

			
			
			
			
			
			
			
			
			
			
					// Show either the timeline event
					// Or the sprite adjust event
			
					if(strlen($timeLineEvent)>5) {
				
						if($fromFrame==1 && $toFrame==1) {
					
							$spriteAdjustCode .= "\n\n-- $name\n\n$spriteAdjustEvent";
					
						} else {
				
							$fromFrame = intval($fromFrame);
							//$fromFrame ++;
				
							if($fromFrame==2) {
								$fromFrame=1;
							}
					
							if($fromFrame==0) {
								$fromFrame=1;
							}
				
							$arrayCounter ++;
							
							if($currentAnimationName != $animationName) {
								$currentAnimationName = $animationName;
								$timeLineCode .= "\n\n-- $animationName \n\n";
							}
								
								
							// If this isn't the first animation, we need to add on total length
							
							if($animationId > 0) {
								$fromFrame += $totalAnimLength;
								$toFrame += $totalAnimLength;
							}
								
					
							if($isBone) {
					
								$timeLineCode .= "timeLine[$arrayCounter] = &#123;$fromFrame,$toFrame,bones[$boneId].sprite,&#123;$timeLineEvent&#125;&#125; -- $name\n";
				
							} else {
					
								$timeLineCode .= "timeLine[$arrayCounter] = &#123;$fromFrame,$toFrame,sprites[$spriteId].sprite,&#123;$timeLineEvent&#125;&#125; -- $name\n";
							}
					
							$timeLineCode = str_replace(",&#125;", "&#125;", $timeLineCode);
				
						}
				
					}
			
		
					$readOutCode.= "<hr style='border: 0; border-top: 1px dashed gray;'>";
				
				// End if this keyframe exists in mainline for this timeline
				}
			
					
			// End for each keyframe in this timeline
			}
		
				$readOutCode.= "<hr>";
		
		// End if this name was in names array
	
		}
	

	
	// End for each <timeline>
	}
	
	$animLength = floor(intval($xml->entity[0]->animation[$animationId][length])*$gTime)-1;
	$totalAnimLength += $animLength;
	
// End for each animation
}





if(count($spriteAdjustCode) > 0) {

	$luaCode .= "\n-- Adjust the sprites (from first frame of timelines)$spriteAdjustCode";
}

if(count($timeLineCode) > 0) {

	$theTimeLine .= "\nlocal timeLine = {}";
	$theTimeLine .= "$timeLineCode";
	$theTimeLine .= "\nself.mc = MovieClip.new(timeLine)";
	$theTimeLine .= "\nself.mc:setGotoAction($numFrames[0],1)";

}



// Now show the data

print("<table border=1 cellpadding=10>
<tr>
<td valign=top width=800>

$readOutCode

</td>


<td valign=top>

<div style='margin-bottom: 20px;'>
<textarea rows=5 cols=100>local mainSprite = Sprite.new()
self:addChild(mainSprite)
mainSprite:setPosition(0, 0)
self.mainSprite = mainSprite</textarea>
</div>

<div style='margin-bottom: 20px;'>
<textarea rows=40 cols=100>$luaCode</textarea>
</div>

<textarea rows=40 cols=100>$theTimeLine</textarea>
</td>

</tr>





");





}






?>